function [g] = objectiveGradient(x)
    global l rho E A_underline A_overline M mu m n_s

    tmp = rho .* l;
    g = [(-.5 * (l .* x(m+1:2*m).^2) ./ (E .* x(1:m).^2)) ...
         + mu * (  (tmp ./ (M - dot(tmp, x(1:m)))) ...
                 - ((x(1:m) - A_underline).^(-1) ...
                 + (A_overline - x(1:m)).^(-1)));
         l .* x(m+1:2*m) ./ (E .* x(1:m));
         zeros(3 * n_s, 1)];
end